app.xhr = (function (window) {
  var xmlhttp;
      
  function init(settings) {
    if (window.XMLHttpRequest) {// code for ie7+, firefox, chrome, opera, safari
      xmlhttp = new XMLHttpRequest();
    } else {// code for ie6, ie5
      xmlhttp = new ActiveXObject('Microsoft.XMLHTTP');
    }
    
    xmlhttp.onreadystatechange = function (settings) {
      if (xmlhttp.readystate === 4 && xmlhttp.status === 200) {
        if (settings.success) {
          settings.success(xmlhttp.responseText);
        }
      }
    };
  }
  
  function open (url, settings) {
    xmlhttp.open(settings.type, url, settings.async);
  }
  
  return {
    name: "xhr.js",
    version: "0.1.0",
    settings: {
      async: false,
      type: 'GET',
      success: null,
      error: null
    },
    ajax: function(url, overrideSettings) {
      var response = '',
          settings;
      try {
        if (!xmlhttp) {
          init();
        }
        settings = overrideSettings || this.settings;
        open(url, settings);
        xmlhttp.send();
        if (!settings.async) {
          if (xmlhttp.status === 200) {
            response = xmlhttp.response;
          } else {
            response = '';
          }
        }
      } catch(e) {
        if (settings.error) {
          settings.error(e);
        }
      }
      return response;
    }
  };
}(window));